diff --git a/lib/hive/commands/setup.rb b/lib/hive/commands/setup.rb
new file mode 100644
index 0000000..435a141
--- /dev/null
+++ b/lib/hive/commands/setup.rb
@@ -0,0 +1,379 @@
+require "fileutils"
+require "json"
+require "stringio"
+require "yaml"
+require "hive/config"
+require "hive/paths"
+require "hive/pid_file"
+require "hive/daemon/consistency_probe"
+require "hive/commands/setup/backend_prompt"
+require "hive/commands/setup/dependency_checks"
+
+module Hive
+  module Commands
+    # `hive setup` — one command that makes a machine (gem/brew/AUR/
+    # install.sh install) fully local-mode ready (U6):
+    #
+    #   1. Dependency matrix — external CLIs (git, tmux, gh, claude, codex,
+    #      node/npm) are checked only, each missing one reported with its
+    #      exact fix command; Hive-owned deps (qmd, web bundle) are repaired.
+    #   2. Agent backends — interactive selection via BackendPrompt
+    #      (defaults silently on non-TTY), persisted to global config.
+    #   3. Daemon — ensure the service is installed (install --force on
+    #      binary drift per U5), started, and the project enrolled.
+    #   4. Web — provision the web bundle (U2), then bring up the managed
+    #      hive-web service (default) or run `hive web` in the foreground
+    #      with --foreground-web.
+    #   5. Summary + next steps.
+    #
+    # Idempotent: safe to re-run as a repair tool. Exit 0 when the
+    # web-critical path is green (provision + boot deps); 65 when blockers
+    # remain, with rows explaining exactly what's left.
+    class Setup
+      EXIT_OK = 0
+      EXIT_BLOCKED = 65
+
+      def initialize(project: nil, json: false, skip_web: false, skip_daemon: false,
+                     foreground_web: false, enroll: true,
+                     output: $stdout, input: $stdin,
+                     checks: nil, provisioner: nil, prompt: nil,
+                     daemon_factory: nil, web_service_factory: nil, env: ENV)
+        @project_override = project
+        @json = json
+        @skip_web = skip_web
+        @skip_daemon = skip_daemon
+        @foreground_web = foreground_web
+        @enroll = enroll
+        @output = output
+        @input = input
+        @checks = checks
+        @provisioner = provisioner
+        @prompt = prompt
+        @daemon_factory = daemon_factory
+        @web_service_factory = web_service_factory
+        @env = env
+        @rows = []
+        @actions = []
+      end
+
+      def call
+        select_backends
+        run_dependency_checks
+        ensure_daemon unless @skip_daemon
+        web_url = ensure_web unless @skip_web
+
+        blocked = @rows.any? { |r| r["status"] == "failed" }
+        emit_summary(web_url: web_url, blocked: blocked)
+        blocked ? EXIT_BLOCKED : EXIT_OK
+      end
+
+      private
+
+      # ── backends ─────────────────────────────────────────────────────
+
+      # Consumes the committed Setup::BackendPrompt seam: non-TTY input
+      # short-circuits to the recommended defaults (claude + codex); an
+      # interactive EOF raises Aborted, which ends setup with a clear
+      # message rather than a backtrace.
+      def select_backends
+        prompt = @prompt || Hive::Commands::Setup::BackendPrompt.new(input: @input, output: @output)
+        selected = prompt.collect
+        Hive::Config.write_global_agents!(selected)
+        @rows << { "name" => "agents", "kind" => "hive", "status" => "present",
+                   "message" => "global backends: #{selected.join(', ')}" }
+      rescue Hive::Commands::Setup::BackendPrompt::Aborted => e
+        @rows << { "name" => "agents", "kind" => "hive", "status" => "failed",
+                   "message" => "backend selection aborted: #{e.message}" }
+      rescue Hive::ConfigError => e
+        @rows << { "name" => "agents", "kind" => "hive", "status" => "failed",
+                   "message" => "could not persist agent backends: #{e.message}" }
+      end
+
+      # ── dependency matrix ────────────────────────────────────────────
+
+      def run_dependency_checks
+        rows = (@checks || Hive::Commands::Setup::DependencyChecks.new(env: @env)).call
+        @rows.concat(rows)
+      end
+
+      # ── daemon ───────────────────────────────────────────────────────
+
+      def ensure_daemon
+        state = read_service_state
+        unless state["service_installed"]
+          run_daemon("install")
+          @actions << "installed hive-daemon service"
+          state = read_service_state
+        end
+
+        probe = Hive::Daemon::ConsistencyProbe.new.call
+        if probe.drifted?
+          run_daemon("install", force: true)
+          @actions << "repaired daemon binary drift (#{probe.drift_kind}) via `hive daemon install --force`"
+          probe = Hive::Daemon::ConsistencyProbe.new.call
+          if probe.drifted?
+            @rows << { "name" => "daemon", "kind" => "hive", "status" => "failed",
+                       "message" => "daemon binary still drifted after repair (#{probe.drift_kind}); " \
+                                    "inspect `hive daemon status --json`" }
+            return
+          end
+        end
+
+        unless daemon_running?
+          run_daemon("start")
+          @actions << "started hive-daemon"
+        end
+
+        if daemon_running?
+          @rows << { "name" => "daemon", "kind" => "hive", "status" => "present",
+                     "message" => "running, service installed, binary consistent" }
+        else
+          @rows << { "name" => "daemon", "kind" => "hive", "status" => "failed",
+                     "message" => "daemon did not come up; check `hive daemon status` and logs" }
+        end
+
+        enroll_project
+      end
+
+      def enroll_project
+        return unless @enroll
+
+        project = registered_project
+        unless project
+          @rows << { "name" => "enroll", "kind" => "hive", "status" => "present",
+                     "message" => "no initialized project in #{project_root} — run `hive init` to create one" }
+          return
+        end
+
+        if daemon_enabled_for?(project)
+          @rows << { "name" => "enroll", "kind" => "hive", "status" => "present",
+                     "message" => "#{project["name"]} already enrolled (daemon.enabled)" }
+          return
+        end
+
+        run_daemon("enable", target: project["name"])
+        @actions << "enrolled project #{project["name"]} (daemon.enabled: true)"
+        @rows << { "name" => "enroll", "kind" => "hive", "status" => "repaired",
+                   "message" => "#{project["name"]} enrolled for daemon dispatch" }
+      rescue Hive::Error, Hive::ConfigError => e
+        @rows << { "name" => "enroll", "kind" => "hive", "status" => "failed",
+                   "message" => "could not enroll project: #{e.message}" }
+      end
+
+      # Enrollment lives in <project>/.hive-state/config.yml (ADR-023) as
+      # `daemon.enabled: true` — the same file `hive daemon enable` writes,
+      # so setup and the daemon agree on what "enrolled" means.
+      def daemon_enabled_for?(project)
+        path = File.join(project["hive_state_path"], "config.yml")
+        return false unless File.exist?(path)
+
+        parsed = YAML.safe_load(File.read(path)) || {}
+        parsed.is_a?(Hash) && parsed.dig("daemon", "enabled") == true
+      rescue Psych::SyntaxError, StandardError
+        false
+      end
+
+      def read_service_state
+        require "hive/commands/daemon/service_installer"
+        Hive::Commands::Daemon::ServiceInstaller.new.service_state
+      rescue StandardError
+        { "service_installed" => nil, "service_enabled" => nil, "unit_path" => nil }
+      end
+
+      def daemon_running?
+        command = daemon_factory.call("status")
+        capture_command_success { command.call }
+      rescue Hive::Error
+        # `daemon status` raises "daemon not running" as its documented
+        # exit-1 contract — that is a state answer, not a setup failure.
+        false
+      end
+
+      # run_daemon invokes Hive::Commands::Daemon subcommands in-process so
+      # the human summary shares the command's exact semantics (typed
+      # errors, envelopes under --json). The non-JSON text output of the
+      # nested command is suppressed — setup renders its own rows.
+      def run_daemon(subcommand, force: false, target: nil)
+        command = daemon_factory.call(subcommand, force: force, target: target)
+        capture_command_success { command.call }
+      rescue Hive::Error => e
+        @rows << { "name" => "daemon", "kind" => "hive", "status" => "failed",
+                   "message" => "`hive daemon #{subcommand}` failed: #{e.message}" }
+        false
+      end
+
+      def daemon_factory
+        @daemon_factory ||= lambda { |subcommand, force: false, target: nil|
+          require "hive/commands/daemon"
+          Hive::Commands::Daemon.new(
+            subcommand,
+            target,
+            detach: true,
+            force: force,
+            all: false,
+            json: false
+          ).tap { |c| c.define_singleton_method(:warn_unsupported_json_flag) {} }
+        }
+      end
+
+      # Swallow nested-command stdout/stderr so setup's own summary stays
+      # readable; success is what matters. Returns truthiness of "no raise".
+      # (Verbose mode via HIVE_SETUP_VERBOSE=1 replays the nested output.)
+      def capture_command_success
+        out = StringIO.new
+        err = StringIO.new
+        original_out = $stdout
+        original_err = $stderr
+        $stdout = out
+        $stderr = err
+        begin
+          yield
+        ensure
+          $stdout = original_out
+          $stderr = original_err
+        end
+        combined = (out.string + err.string).strip
+        @output.puts combined if @env["HIVE_SETUP_VERBOSE"] == "1" && !combined.empty?
+        true
+      rescue Hive::Error
+        raise
+      rescue StandardError => e
+        @output.puts "hive setup: nested command error: #{e.message}"
+        false
+      end
+
+      # ── web ──────────────────────────────────────────────────────────
+
+      # Brings web up: provision (U2) then the managed hive-web service
+      # (install + start), or foreground `hive web` with --foreground-web.
+      # Returns the web URL for the summary (nil on foreground — the exec
+      # replaces this process — and on failure).
+      def ensure_web
+        provision_web
+        return nil if @rows.any? { |r| r["name"] == "web-app" && r["status"] == "failed" }
+
+        if @foreground_web
+          @rows << { "name" => "web", "kind" => "hive", "status" => "present",
+                     "message" => "launching `hive web` in the foreground (Ctrl-C stops it)" }
+          require "hive/commands/web"
+          url = web_url
+          emit_summary(web_url: url, blocked: false)
+          Hive::Commands::Web.new.call # Kernel.exec replaces this process
+        end
+
+        install_and_start_web_service
+        web_url
+      end
+
+      def provision_web
+        provisioner.provision!
+        @rows << { "name" => "web-app", "kind" => "hive", "status" => "repaired",
+                   "message" => "web bundle ready at #{provisioner.managed_app_dir}" }
+      rescue Hive::WebApp::Provisioner::ProvisioningFailed => e
+        @rows << { "name" => "web-app", "kind" => "hive", "status" => "failed", "message" => e.message }
+      end
+
+      def install_and_start_web_service
+        install_ok = run_web_service("install")
+        start_ok = install_ok && run_web_service("start")
+        if install_ok && start_ok
+          @rows << { "name" => "web", "kind" => "hive", "status" => "present",
+                     "message" => "hive-web service installed and started (#{web_url})" }
+        else
+          @rows << { "name" => "web", "kind" => "hive", "status" => "failed",
+                     "message" => "hive-web service could not be started; run `hive web install` / `hive web start` for detail" }
+        end
+      end
+
+      def run_web_service(subcommand)
+        command = web_service_factory.call(subcommand)
+        capture_command_success { command.call }
+      rescue Hive::Error => e
+        @rows << { "name" => "web", "kind" => "hive", "status" => "failed",
+                   "message" => "`hive web #{subcommand}` failed: #{e.message}" }
+        false
+      end
+
+      def web_service_factory
+        @web_service_factory ||= lambda { |subcommand|
+          require "hive/commands/web_service"
+          Hive::Commands::WebService.new(subcommand, json: false)
+        }
+      end
+
+      def provisioner
+        @provisioner ||= begin
+          require "hive/web_app/provisioner"
+          Hive::WebApp::Provisioner.new
+        end
+      end
+
+      # ── project / summary ────────────────────────────────────────────
+
+      def registered_project
+        path = File.expand_path(project_root)
+        Hive::Config.registered_projects.find do |p|
+          File.expand_path(p["path"]) == path
+        end
+      end
+
+      def web_url
+        cfg = Hive::Config.load_global_web
+        "http://#{cfg.fetch('bind')}:#{cfg.fetch('port')}"
+      rescue Hive::Error
+        nil
+      end
+
+      def emit_summary(web_url:, blocked:)
+        if @json
+          payload = {
+            "schema" => "hive-setup",
+            "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-setup"),
+            "ok" => !blocked,
+            "rows" => @rows,
+            "actions" => @actions,
+            "web_url" => web_url
+          }
+          @output.puts JSON.generate(payload)
+          return
+        end
+
+        @output.puts ""
+        @output.puts "hive setup — summary"
+        @output.puts "--------------------"
+        @rows.each do |row|
+          marker = case row["status"]
+                   when "present" then "✓"
+                   when "repaired" then "↻"
+                   when "missing" then "!"
+                   else "✗"
+                   end
+          @output.puts format("  %-12s %s %s", row["name"], marker, row["message"])
+        end
+        @output.puts ""
+        unless @actions.empty?
+          @output.puts "Actions taken:"
+          @actions.each { |a| @output.puts "  - #{a}" }
+          @output.puts ""
+        end
+        if web_url
+          @output.puts "Web UI: #{web_url} (loopback binds need no login)"
+        end
+        @output.puts "Next steps:"
+        @output.puts "  - hive new <project> \"<task text>\"   # create a task from the TUI or web composer"
+        @output.puts "  - hive daemon status                  # watch the dispatcher"
+        missing = @rows.select { |r| r["status"] == "missing" }
+        missing.each { |r| @output.puts "  - install #{r["name"]}: #{r["message"]}" }
+        @output.puts ""
+      end
+
+      def project_root
+        @project_root ||= @project_override || Dir.pwd
+      end
+
+      def warn(message)
+        @output.puts "hive setup: #{message}"
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/setup/dependency_checks.rb b/lib/hive/commands/setup/dependency_checks.rb
new file mode 100644
index 0000000..5284164
--- /dev/null
+++ b/lib/hive/commands/setup/dependency_checks.rb
@@ -0,0 +1,146 @@
+require "open3"
+require "hive/commands/doctor"
+
+module Hive
+  module Commands
+    class Setup
+      # Dependency matrix for `hive setup` (U6). Reuses the doctor's probe
+      # discipline (PATH lookups, qmd discovery order) with the setup
+      # policy split:
+      #
+      #   External CLIs (git, tmux, gh, claude, codex, node/npm) are CHECKED
+      #   ONLY — never installed, never authenticated. Each missing tool is
+      #   reported with its exact per-platform fix command.
+      #
+      #   Hive-owned deps (qmd, the web bundle) are REPAIRED: qmd via the
+      #   same `npm install --global --prefix <data>/hive/qmd @tobilu/qmd`
+      #   command the update flow emits, the web bundle via the U2
+      #   provisioner (orchestrated by Setup itself, not here).
+      #
+      # Rows are plain {name:, kind:, status:, message:} hashes; status is
+      # one of present / missing / repaired / failed. `kind` distinguishes
+      # external (checked only) from hive (repaired).
+      class DependencyChecks
+        # Exact per-platform install hints. Debian/Ubuntu + Homebrew cover
+        # the documented Linux + macOS first-class platforms.
+        EXTERNAL_TOOLS = {
+          "git" => "sudo apt install git (Debian/Ubuntu) or brew install git (macOS)",
+          "tmux" => "sudo apt install tmux (Debian/Ubuntu) or brew install tmux (macOS)",
+          "gh" => "https://cli.github.com/ or brew install gh (macOS)",
+          "claude" => "npm install --global @anthropic-ai/claude-code (authenticate with `claude` afterwards)",
+          "codex" => "npm install --global @openai/codex (authenticate with `codex` afterwards)",
+          "node" => "https://nodejs.org/ or brew install node (macOS) — also provides npm",
+          "npm" => "installed with Node.js — see https://nodejs.org/ or brew install node (macOS)"
+        }.freeze
+
+        QMD_PACKAGE = "@tobilu/qmd"
+
+        attr_reader :rows
+
+        def initialize(env: ENV, runner: nil, qmd_finder: nil)
+          @env = env
+          @runner = runner
+          @qmd_finder = qmd_finder
+          @rows = []
+        end
+
+        def call
+          check_ruby
+          EXTERNAL_TOOLS.each_key { |tool| check_external(tool) }
+          check_qmd
+          rows
+        end
+
+        private
+
+        def row(name, kind, status, message)
+          @rows << { "name" => name, "kind" => kind, "status" => status, "message" => message }
+        end
+
+        def check_ruby
+          major = RUBY_VERSION.to_s.split(".").first(2).map(&:to_i)
+          if major.first > 3 || (major.first == 3 && major.last >= 4)
+            row("ruby", "external", "present", "Ruby #{RUBY_VERSION} (web runs under this interpreter)")
+          else
+            row("ruby", "external", "missing",
+                "Ruby >= 3.4 required; got #{RUBY_VERSION}. Install with mise/rbenv or your package manager.")
+          end
+        end
+
+        def check_external(tool)
+          if which(tool)
+            row(tool, "external", "present", which(tool))
+          else
+            row(tool, "external", "missing", "#{tool} not found on PATH; fix: #{EXTERNAL_TOOLS.fetch(tool)}")
+          end
+        end
+
+        # qmd is Hive-owned: when missing AND npm is available, run the exact
+        # repair command the update flow/doctor emit. npm missing → failed
+        # row with guidance (npm is external — never installed here).
+        def check_qmd
+          if qmd_finder.call
+            row("qmd", "hive", "present", "qmd at #{qmd_finder.call}")
+            return
+          end
+
+          unless which("npm")
+            row("qmd", "hive", "failed",
+                "qmd is not installed and npm is missing — install Node.js/npm first, " \
+                "then run: npm install --global --prefix \"#{qmd_prefix}\" #{QMD_PACKAGE}")
+            return
+          end
+
+          ok = runner.call(
+            [ "npm", "install", "--global", "--prefix", qmd_prefix, QMD_PACKAGE ],
+            chdir: Dir.home
+          )
+          if ok
+            repaired = qmd_finder.call
+            if repaired
+              row("qmd", "hive", "repaired", "installed qmd into #{qmd_prefix} (#{repaired})")
+            else
+              row("qmd", "hive", "failed",
+                  "qmd install ran but the binary is not discoverable; check the npm output, " \
+                  "or set HIVE_QMD_BIN to the qmd executable")
+            end
+          else
+            row("qmd", "hive", "failed",
+                "qmd repair failed; run manually: npm install --global --prefix \"#{qmd_prefix}\" #{QMD_PACKAGE}")
+          end
+        end
+
+        # Mirrors doctor's qmd discovery (shared Hive::QmdLookup) so setup
+        # and doctor agree on what "installed" means.
+        def qmd_finder
+          @qmd_finder ||= -> { Hive::QmdLookup.qmd_bin(env: @env) }
+        end
+
+        def qmd_prefix
+          data_home = @env["XDG_DATA_HOME"].to_s.empty? ? File.join(home, ".local/share") : @env["XDG_DATA_HOME"]
+          File.join(data_home, "hive", "qmd")
+        end
+
+        def home
+          @env.fetch("HOME") { Dir.home }
+        end
+
+        def runner
+          @runner ||= lambda { |argv, chdir: nil, env: nil|
+            out, err, status = Open3.capture3(env || {}, *argv, chdir: chdir)
+            [ out, err ].each { |io| warn io unless io.strip.empty? }
+            status.success?
+          }
+        end
+
+        def which(name)
+          @env.fetch("PATH", "").split(File::PATH_SEPARATOR).each do |dir|
+            path = File.join(dir, name)
+            return path if File.file?(path) && File.executable?(path)
+          end
+          nil
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/web.rb b/lib/hive/commands/web.rb
index eb3cd40..881b363 100644
--- a/lib/hive/commands/web.rb
+++ b/lib/hive/commands/web.rb
@@ -1,30 +1,46 @@
 require "hive/config"
+require "hive/web/auth_mode"
 require "hive/web/session_secret"
 
 module Hive
   module Commands
     # Boots the hivebox web UI — a Rails app living in web/ at the repo root
     # (shipped in the Docker image at /app/web). hive itself stays a plain
-    # CLI gem; the web tier is only supported where the Rails app and its
-    # bundle exist: the hivebox container or a source checkout.
+    # CLI gem; the web tier is supported where the Rails app and its bundle
+    # exist: the hivebox container, a source checkout, or a managed copy
+    # provisioned by `hive setup` / `Hive::WebApp::Provisioner`.
+    #
+    # Auth resolution (U1): on a loopback bind with no configured owner the
+    # command exports HIVEBOX_LOCAL_NOAUTH=1 so the Rails app grants a
+    # tokenless local session (single-user contract). A non-loopback bind
+    # that would resolve to no-auth is refused unless `--allow-public-noauth`
+    # is passed — misconfiguration must fail fast with the exact fix, not
+    # silently expose the box.
     class Web
-      def initialize(bind: nil, port: nil)
+      # Typed guidance error for the no-auth-on-public-bind refusal. Raised
+      # before any server boot so the fix is actionable, not a 403 maze.
+      class PublicNoAuthRefused < Hive::Error; end
+
+      def initialize(bind: nil, port: nil, allow_public_noauth: false,
+                     provision: false, assume_yes: false)
         @bind = bind
         @port = port
+        @allow_public_noauth = allow_public_noauth
+        @provision = provision
+        @assume_yes = assume_yes
       end
 
       def call
         cfg = Hive::Config.load_global_web
         bind = @bind || cfg.fetch("bind")
         port = (@port || cfg.fetch("port")).to_i
-        app_dir = rails_app_dir
+        app_dir = locate_app_dir
         unless app_dir
-          warn "hive web: the hivebox web app (web/) was not found. " \
-               "Run from the hivebox Docker image or a source checkout, " \
-               "or point HIVEBOX_WEB_APP_DIR at the Rails app."
+          warn_missing_app
           exit 1
         end
 
+        resolve_auth!(bind, cfg)
         warn_on_public_bind(bind, cfg)
 
         env = {
@@ -42,6 +58,7 @@ module Hive
             File.join(Hive::Paths.state_home, "web-storage"),
           "BUNDLE_GEMFILE" => File.join(app_dir, "Gemfile")
         }
+        env[Hive::Web::AuthMode::LOCAL_NOAUTH_ENV] = "1" if @auth_mode == Hive::Web::AuthMode::NONE
         FileUtils.mkdir_p(env.fetch("HIVEBOX_STORAGE_DIR"))
 
         Dir.chdir(app_dir) do
@@ -64,12 +81,58 @@ module Hive
 
       private
 
+      def locate_app_dir
+        dir = provisioner.locate
+        return dir if dir
+
+        return nil unless provisioning_available?
+
+        provisioner.provision!
+      end
+
+      # Provisioning is opt-in (`hive web --yes`, or `hive setup`): a bare
+      # `hive web` on a machine with no web app must not surprise the
+      # operator with a network download. It exits 1 pointing at the
+      # one-command setup instead.
+      def provisioning_available?
+        @provision || @assume_yes
+      end
+
+      def provisioner
+        require "hive/web_app/provisioner"
+        @provisioner ||= Hive::WebApp::Provisioner.new(
+          assume_yes: @assume_yes || @provision
+        )
+      end
+
+      def warn_missing_app
+        warn "hive web: the hivebox web app (web/) was not found. " \
+             "Run from the hivebox Docker image or a source checkout, " \
+             "run `hive setup` to provision and launch web, " \
+             "or point HIVEBOX_WEB_APP_DIR at the Rails app."
+      end
+
+      # Resolves the effective auth mode (AuthMode.resolve) and enforces the
+      # refusal matrix BEFORE any server boot:
+      #   none + loopback bind                → export the no-auth env
+      #   none + non-loopback bind            → refuse unless the unsafe flag
+      #   github (any bind)                   → device-flow owner gate as-is
+      def resolve_auth!(bind, cfg)
+        @auth_mode = Hive::Web::AuthMode.resolve(cfg)
+        return unless @auth_mode == Hive::Web::AuthMode::NONE
+        return if Hive::Web::AuthMode.loopback_bind?(bind)
+        return if @allow_public_noauth
+
+        raise PublicNoAuthRefused,
+              "hive web: this bind (#{bind}) is not loopback and no auth is available " \
+              "(web.github.owner is unset), so the web UI would be editable by anyone " \
+              "who can reach the port. Fix with one of: keep the default loopback bind " \
+              "(127.0.0.1), set web.auth: github and claim an owner, or pass " \
+              "--allow-public-noauth if you accept the risk."
+      end
+
       def rails_app_dir
-        candidates = [
-          ENV["HIVEBOX_WEB_APP_DIR"],
-          File.expand_path("../../../web", __dir__)
-        ].compact
-        candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
+        provisioner.locate
       end
 
       # Rails' production host authorization is inactive by default — the box
diff --git a/lib/hive/commands/web/service_installer.rb b/lib/hive/commands/web/service_installer.rb
new file mode 100644
index 0000000..1260866
--- /dev/null
+++ b/lib/hive/commands/web/service_installer.rb
@@ -0,0 +1,77 @@
+require "cgi"
+require "shellwords"
+require "hive/commands/service_installer/base"
+
+module Hive
+  module Commands
+    class Web
+      # Per-user autostart service for the hive web UI (`hive-web`), built on
+      # the same proven mechanics as the daemon installer: systemd-user
+      # `enable --now` on Linux, launchd load on macOS, drift detection with
+      # timestamped backups, and force-upgrade restarts. The unit runs the
+      # SAME foreground `hive web` process, so the service and manual paths
+      # share all code — the only difference is who supervises it.
+      class ServiceInstaller < Hive::Commands::ServiceInstaller::Base
+        def service_name
+          "hive-web"
+        end
+
+        def cli_label
+          "web"
+        end
+
+        def service_noun
+          "web service"
+        end
+
+        def unit_noun
+          "web unit"
+        end
+
+        def target_path
+          case platform
+          when :macos then File.join(@home, "Library/LaunchAgents/local.hive-web.plist")
+          when :linux then File.join(@home, ".config/systemd/user/hive-web.service")
+          end
+        end
+
+        # The web server has no long drain phase like the daemon's in-flight
+        # children; a force-upgrade restart returns quickly.
+        def upgrade_restart_warning
+          nil
+        end
+
+        private
+
+        def render_systemd
+          template = File.read(File.expand_path("../../../../examples/systemd/hive-web.service", __dir__))
+          # systemd .service files are POSIX-shell-ish — escape the
+          # resolved binary path so whitespace, `%`, or other special
+          # characters don't produce a malformed unit.
+          escaped = Shellwords.escape(resolved_binary)
+          template
+            .sub(/^ExecStart=.*$/, "ExecStart=#{escaped} web")
+            .sub(/^Environment=HIVE_BIN=.*$/, "Environment=HIVE_BIN=#{escaped}")
+            .sub(/^Environment=PATH=.*$/, build_path_line)
+        end
+
+        def render_launchd
+          template = File.read(File.expand_path("../../../../examples/launchd/hive-web.plist", __dir__))
+          binary = resolved_binary
+          # dirname BEFORE HTML-escaping so paths with `&`/`<`/`>` get
+          # the correct directory segmentation; then escape both for
+          # plist XML safety.
+          binary_dir = File.dirname(binary)
+          escaped_binary = CGI.escapeHTML(binary)
+          escaped_binary_dir = CGI.escapeHTML(binary_dir)
+          escaped_home = CGI.escapeHTML(@home)
+          template
+            .gsub(%r{<string>/Users/YOU/\.local/bin/hive</string>}, "<string>#{escaped_binary}</string>")
+            .gsub("/Users/YOU/Library/Logs/hive-web.out.log", "#{escaped_home}/Library/Logs/hive-web.out.log")
+            .gsub("/Users/YOU/Library/Logs/hive-web.err.log", "#{escaped_home}/Library/Logs/hive-web.err.log")
+            .gsub("/Users/YOU/.local/bin", escaped_binary_dir)
+        end
+      end
+    end
+  end
+end
